@echo off

rem
rem  This batch file creates a tiled image called Final.png and a 3x3 array of them as Array.png from an input image
rem  It requires two parameters. The first is a flattening value where 0=None, 1=Light, 2=Moderate, 3=High
rem  The second parameter is the starting image filename
rem  Flattening an image means that it makes the contrast of the image more uniform over the tile so that it appears
rem  better when tiled.
rem
rem  To run this script requires an installation of ImageMagick, www.imagemagick.org
rem
rem  This script and supporting image are copyright (c) Redrobes of ViewingDale Jan 2008 with some rights reserved.
rem  See www.ViewingDale.com, You can mail on the contact page on that site for support.
rem
rem  You may distribute this script under the licence of :-
rem  Creative Commons Attribution-Share Alike 2.0 UK: England & Wales License
rem  http://creativecommons.org/licenses/by-sa/2.0/uk/
rem  I.e. just keep this header and use as you see fit.
rem
rem  If anyone would like to convert this to a CGI webpage running on a server with adequate processing power then
rem  please get in touch as that would be most welcome.
rem
rem  May it prove useful to you.
rem

if not "%1"=="" goto param1def
echo First param is flattening number 0-3. 0=None, 1=Light, 2=Moderate, 3=High
pause
goto end

:param1def

if %1==0 goto gotparam1
if %1==1 goto gotparam1
if %1==2 goto gotparam1
if %1==3 goto gotparam1
echo First param is flattening number 0-3. 0=None, 1=Light, 2=Moderate, 3=High
pause
goto end

:gotparam1

if exist %2 goto gotparam2
echo Second param is image filename
pause
goto end

:gotparam2

if exist VertRgn.png goto gotrgn
echo Missing file VertRgn.png
pause
goto end

:gotrgn

if not exist HorzRgn.png convert VertRgn.png -rotate 90 HorzRgn.png

echo Starting image tile, this may take a short while...

convert %2 -resize 1024x1024! tmp1.png
montage tmp1.png tmp1.png tmp1.png tmp1.png -geometry +0+0 tmp2.png
composite -compose CopyOpacity VertRgn.png tmp1.png vert.png
composite -compose CopyOpacity HorzRgn.png tmp1.png horz.png
composite -geometry +512+512 vert.png tmp2.png tmp2.png
composite -geometry +512+512 horz.png tmp2.png tmp2.png
convert -extent 1024x1024+512+512 tmp2.png tmp2.png
montage tmp2.png tmp2.png tmp2.png tmp2.png -geometry +0+0 tmp2.png
convert -extent 1024x1024+512+512 tmp2.png tmp2.png

:flat0
if not %1==0 goto flat1
REM No Flattening
copy tmp2.png Final.png
goto endflat

:flat1
if not %1==1 goto flat2
echo Starting Normal/Low flattening, this may take a short while...
convert -resize 16x16 tmp2.png tmp3.png
goto endblur

:flat2
if not %1==2 goto flat3
echo Starting Moderate flattening, this may take a short while...
convert -resize 32x32 tmp2.png tmp3.png
goto endblur

:flat3
echo Starting Lots of flattening, this may take a short while...
convert -resize 64x64 tmp2.png tmp3.png
goto endblur

:endblur

convert -blur 50 tmp3.png tmp3.png
convert -resize 8x8 tmp3.png tmp4.png
convert -blur 50 tmp4.png tmp4.png
convert -extent 1x1+4+4 tmp4.png tmp4.png
convert -resize 1024x1024 tmp4.png tmp4.png
convert -resize 1024x1024 tmp3.png tmp3.png
convert -blur 50 tmp3.png tmp3.png
convert tmp3.png tmp4.png -compose minus -composite tmp5.png
convert tmp4.png tmp3.png -compose minus -composite tmp6.png
convert tmp2.png tmp5.png -compose plus -composite tmp7.png
convert tmp6.png tmp7.png -compose minus -composite Final.png

:endflat

echo Done Final.png, creating 3x3 tile montage using this image as Array.png
montage Final.png Final.png Final.png Final.png Final.png Final.png Final.png Final.png Final.png -geometry +0+0 Array.png

echo Cleanup
if exist tmp1.png del tmp1.png
if exist tmp2.png del tmp2.png
if exist tmp3.png del tmp3.png
if exist tmp4.png del tmp4.png
if exist tmp5.png del tmp5.png
if exist tmp6.png del tmp6.png
if exist tmp7.png del tmp7.png
if exist horz.png del horz.png
if exist vert.png del vert.png

echo All Done !
pause
:end
